/* unity-scope-proxy.c generated by valac 0.15.0, the Vala compiler
 * generated from unity-scope-proxy.vala, do not modify */

/*
 * Copyright (C) 2011 Canonical, Ltd.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * version 3.0 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3.0 for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see
 * <http://www.gnu.org/licenses/>.
 *
 * Authored by Neil Jagdish Patel <neil.patel@canonical.com>
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include "unity.h"
#include <dee.h>


#define UNITY_TYPE_SCOPE_PROXY (unity_scope_proxy_get_type ())
#define UNITY_SCOPE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), UNITY_TYPE_SCOPE_PROXY, UnityScopeProxy))
#define UNITY_IS_SCOPE_PROXY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UNITY_TYPE_SCOPE_PROXY))
#define UNITY_SCOPE_PROXY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), UNITY_TYPE_SCOPE_PROXY, UnityScopeProxyIface))

typedef struct _UnityScopeProxy UnityScopeProxy;
typedef struct _UnityScopeProxyIface UnityScopeProxyIface;

#define UNITY_TYPE_ACTIVATION_REPLY_RAW (unity_activation_reply_raw_get_type ())
typedef struct _UnityActivationReplyRaw UnityActivationReplyRaw;

#define UNITY_TYPE_PREVIEW_REPLY_RAW (unity_preview_reply_raw_get_type ())
typedef struct _UnityPreviewReplyRaw UnityPreviewReplyRaw;

#define UNITY_TYPE_VIEW_TYPE (unity_view_type_get_type ())

struct _UnityActivationReplyRaw {
	gchar* uri;
	guint handled;
	GHashTable* hints;
};

struct _UnityPreviewReplyRaw {
	gchar* uri;
	gchar* renderer_name;
	GHashTable* properties;
};

typedef enum  {
	UNITY_VIEW_TYPE_HIDDEN,
	UNITY_VIEW_TYPE_HOME_VIEW,
	UNITY_VIEW_TYPE_LENS_VIEW
} UnityViewType;

struct _UnityScopeProxyIface {
	GTypeInterface parent_iface;
	void (*activate) (UnityScopeProxy* self, const gchar* uri, guint action_type, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*activate_finish) (UnityScopeProxy* self, GAsyncResult* _res_, UnityActivationReplyRaw* result);
	void (*search) (UnityScopeProxy* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GHashTable* (*search_finish) (UnityScopeProxy* self, GAsyncResult* _res_);
	void (*global_search) (UnityScopeProxy* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
	GHashTable* (*global_search_finish) (UnityScopeProxy* self, GAsyncResult* _res_);
	void (*preview) (UnityScopeProxy* self, const gchar* uri, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*preview_finish) (UnityScopeProxy* self, GAsyncResult* _res_, UnityPreviewReplyRaw* result);
	void (*set_active_sources) (UnityScopeProxy* self, gchar** sources, int sources_length1, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*set_active_sources_finish) (UnityScopeProxy* self, GAsyncResult* _res_);
	UnityOptionsFilter* (*get_sources) (UnityScopeProxy* self);
	void (*set_sources) (UnityScopeProxy* self, UnityOptionsFilter* value);
	gboolean (*get_search_in_global) (UnityScopeProxy* self);
	void (*set_search_in_global) (UnityScopeProxy* self, gboolean value);
	UnityViewType (*get_view_type) (UnityScopeProxy* self);
	void (*set_view_type) (UnityScopeProxy* self, UnityViewType value);
	DeeSerializableModel* (*get_results_model) (UnityScopeProxy* self);
	void (*set_results_model) (UnityScopeProxy* self, DeeSerializableModel* value);
	DeeSerializableModel* (*get_global_results_model) (UnityScopeProxy* self);
	void (*set_global_results_model) (UnityScopeProxy* self, DeeSerializableModel* value);
	DeeSerializableModel* (*get_filters_model) (UnityScopeProxy* self);
	void (*set_filters_model) (UnityScopeProxy* self, DeeSerializableModel* value);
};



GType unity_activation_reply_raw_get_type (void) G_GNUC_CONST;
UnityActivationReplyRaw* unity_activation_reply_raw_dup (const UnityActivationReplyRaw* self);
void unity_activation_reply_raw_free (UnityActivationReplyRaw* self);
void unity_activation_reply_raw_copy (const UnityActivationReplyRaw* self, UnityActivationReplyRaw* dest);
void unity_activation_reply_raw_destroy (UnityActivationReplyRaw* self);
GType unity_preview_reply_raw_get_type (void) G_GNUC_CONST;
UnityPreviewReplyRaw* unity_preview_reply_raw_dup (const UnityPreviewReplyRaw* self);
void unity_preview_reply_raw_free (UnityPreviewReplyRaw* self);
void unity_preview_reply_raw_copy (const UnityPreviewReplyRaw* self, UnityPreviewReplyRaw* dest);
void unity_preview_reply_raw_destroy (UnityPreviewReplyRaw* self);
GType unity_view_type_get_type (void) G_GNUC_CONST;
GType unity_scope_proxy_get_type (void) G_GNUC_CONST;
void unity_scope_proxy_activate (UnityScopeProxy* self, const gchar* uri, guint action_type, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_scope_proxy_activate_finish (UnityScopeProxy* self, GAsyncResult* _res_, UnityActivationReplyRaw* result);
void unity_scope_proxy_search (UnityScopeProxy* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
GHashTable* unity_scope_proxy_search_finish (UnityScopeProxy* self, GAsyncResult* _res_);
void unity_scope_proxy_global_search (UnityScopeProxy* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_);
GHashTable* unity_scope_proxy_global_search_finish (UnityScopeProxy* self, GAsyncResult* _res_);
void unity_scope_proxy_preview (UnityScopeProxy* self, const gchar* uri, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_scope_proxy_preview_finish (UnityScopeProxy* self, GAsyncResult* _res_, UnityPreviewReplyRaw* result);
void unity_scope_proxy_set_active_sources (UnityScopeProxy* self, gchar** sources, int sources_length1, GAsyncReadyCallback _callback_, gpointer _user_data_);
void unity_scope_proxy_set_active_sources_finish (UnityScopeProxy* self, GAsyncResult* _res_);
UnityOptionsFilter* unity_scope_proxy_get_sources (UnityScopeProxy* self);
void unity_scope_proxy_set_sources (UnityScopeProxy* self, UnityOptionsFilter* value);
gboolean unity_scope_proxy_get_search_in_global (UnityScopeProxy* self);
void unity_scope_proxy_set_search_in_global (UnityScopeProxy* self, gboolean value);
UnityViewType unity_scope_proxy_get_view_type (UnityScopeProxy* self);
void unity_scope_proxy_set_view_type (UnityScopeProxy* self, UnityViewType value);
DeeSerializableModel* unity_scope_proxy_get_results_model (UnityScopeProxy* self);
void unity_scope_proxy_set_results_model (UnityScopeProxy* self, DeeSerializableModel* value);
DeeSerializableModel* unity_scope_proxy_get_global_results_model (UnityScopeProxy* self);
void unity_scope_proxy_set_global_results_model (UnityScopeProxy* self, DeeSerializableModel* value);
DeeSerializableModel* unity_scope_proxy_get_filters_model (UnityScopeProxy* self);
void unity_scope_proxy_set_filters_model (UnityScopeProxy* self, DeeSerializableModel* value);


void unity_scope_proxy_activate (UnityScopeProxy* self, const gchar* uri, guint action_type, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->activate (self, uri, action_type, _callback_, _user_data_);
}


void unity_scope_proxy_activate_finish (UnityScopeProxy* self, GAsyncResult* _res_, UnityActivationReplyRaw* result) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->activate_finish (self, _res_, result);
}


void unity_scope_proxy_search (UnityScopeProxy* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->search (self, search_string, hints, _callback_, _user_data_);
}


GHashTable* unity_scope_proxy_search_finish (UnityScopeProxy* self, GAsyncResult* _res_) {
	return UNITY_SCOPE_PROXY_GET_INTERFACE (self)->search_finish (self, _res_);
}


void unity_scope_proxy_global_search (UnityScopeProxy* self, const gchar* search_string, GHashTable* hints, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->global_search (self, search_string, hints, _callback_, _user_data_);
}


GHashTable* unity_scope_proxy_global_search_finish (UnityScopeProxy* self, GAsyncResult* _res_) {
	return UNITY_SCOPE_PROXY_GET_INTERFACE (self)->global_search_finish (self, _res_);
}


void unity_scope_proxy_preview (UnityScopeProxy* self, const gchar* uri, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->preview (self, uri, _callback_, _user_data_);
}


void unity_scope_proxy_preview_finish (UnityScopeProxy* self, GAsyncResult* _res_, UnityPreviewReplyRaw* result) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->preview_finish (self, _res_, result);
}


void unity_scope_proxy_set_active_sources (UnityScopeProxy* self, gchar** sources, int sources_length1, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->set_active_sources (self, sources, sources_length1, _callback_, _user_data_);
}


void unity_scope_proxy_set_active_sources_finish (UnityScopeProxy* self, GAsyncResult* _res_) {
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->set_active_sources_finish (self, _res_);
}


UnityOptionsFilter* unity_scope_proxy_get_sources (UnityScopeProxy* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return UNITY_SCOPE_PROXY_GET_INTERFACE (self)->get_sources (self);
}


void unity_scope_proxy_set_sources (UnityScopeProxy* self, UnityOptionsFilter* value) {
	g_return_if_fail (self != NULL);
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->set_sources (self, value);
}


gboolean unity_scope_proxy_get_search_in_global (UnityScopeProxy* self) {
	g_return_val_if_fail (self != NULL, FALSE);
	return UNITY_SCOPE_PROXY_GET_INTERFACE (self)->get_search_in_global (self);
}


void unity_scope_proxy_set_search_in_global (UnityScopeProxy* self, gboolean value) {
	g_return_if_fail (self != NULL);
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->set_search_in_global (self, value);
}


UnityViewType unity_scope_proxy_get_view_type (UnityScopeProxy* self) {
	g_return_val_if_fail (self != NULL, 0);
	return UNITY_SCOPE_PROXY_GET_INTERFACE (self)->get_view_type (self);
}


void unity_scope_proxy_set_view_type (UnityScopeProxy* self, UnityViewType value) {
	g_return_if_fail (self != NULL);
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->set_view_type (self, value);
}


DeeSerializableModel* unity_scope_proxy_get_results_model (UnityScopeProxy* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return UNITY_SCOPE_PROXY_GET_INTERFACE (self)->get_results_model (self);
}


void unity_scope_proxy_set_results_model (UnityScopeProxy* self, DeeSerializableModel* value) {
	g_return_if_fail (self != NULL);
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->set_results_model (self, value);
}


DeeSerializableModel* unity_scope_proxy_get_global_results_model (UnityScopeProxy* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return UNITY_SCOPE_PROXY_GET_INTERFACE (self)->get_global_results_model (self);
}


void unity_scope_proxy_set_global_results_model (UnityScopeProxy* self, DeeSerializableModel* value) {
	g_return_if_fail (self != NULL);
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->set_global_results_model (self, value);
}


DeeSerializableModel* unity_scope_proxy_get_filters_model (UnityScopeProxy* self) {
	g_return_val_if_fail (self != NULL, NULL);
	return UNITY_SCOPE_PROXY_GET_INTERFACE (self)->get_filters_model (self);
}


void unity_scope_proxy_set_filters_model (UnityScopeProxy* self, DeeSerializableModel* value) {
	g_return_if_fail (self != NULL);
	UNITY_SCOPE_PROXY_GET_INTERFACE (self)->set_filters_model (self, value);
}


static void unity_scope_proxy_base_init (UnityScopeProxyIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_object_interface_install_property (iface, g_param_spec_object ("sources", "sources", "sources", UNITY_TYPE_OPTIONS_FILTER, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_boolean ("search-in-global", "search-in-global", "search-in-global", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_enum ("view-type", "view-type", "view-type", UNITY_TYPE_VIEW_TYPE, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_object ("results-model", "results-model", "results-model", dee_serializable_model_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_object ("global-results-model", "global-results-model", "global-results-model", dee_serializable_model_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
		g_object_interface_install_property (iface, g_param_spec_object ("filters-model", "filters-model", "filters-model", dee_serializable_model_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	}
}


GType unity_scope_proxy_get_type (void) {
	static volatile gsize unity_scope_proxy_type_id__volatile = 0;
	if (g_once_init_enter (&unity_scope_proxy_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UnityScopeProxyIface), (GBaseInitFunc) unity_scope_proxy_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType unity_scope_proxy_type_id;
		unity_scope_proxy_type_id = g_type_register_static (G_TYPE_INTERFACE, "UnityScopeProxy", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (unity_scope_proxy_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&unity_scope_proxy_type_id__volatile, unity_scope_proxy_type_id);
	}
	return unity_scope_proxy_type_id__volatile;
}



